-------------------------------------------------------------------------------
-- File name : top.vhd
-- Title     : Testbench
-- project   : ECE 485
-- Library   : multi-cycle processor
-- Author(s) : Ivan Castellanos
-- Purpose   : definition of multi-cycle processor
-- notes     : program is stored in mem512.dat  
--           : mem512.mif explains contents of test program

-- Copyright Illinois Institute of Technology
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity top is
  
end top;

architecture struct of top is

  component mipsmc 
    port (clk        :in  std_logic;
          reset_l    :in  std_logic;
          ack_o      :in  std_logic;
          adr_i      :out std_logic_vector(  8 downto 0 );
          clk_i      :out std_logic;
          dat_i      :out std_logic_vector( 31 downto 0 );
          dat_o      :in  std_logic_vector( 31 downto 0 );
          stb_i      :out std_logic;
          we_i       :out std_logic);
  end component;

  component memwb 
    port (ack_o : out std_logic;
          adr_i : in  std_logic_vector(  8 downto 0 );
          clk_i : in  std_logic;
          dat_i : in  std_logic_vector( 31 downto 0 );
          dat_o : out std_logic_vector( 31 downto 0 );
          stb_i : in  std_logic;
          we_i  : in  std_logic);
  end component;

  signal clk    :std_logic;
  signal Reset_l:std_logic;
  signal ACK_O  :std_logic;
  signal ADR_I  :std_logic_vector(8 downto 0);
  signal CLK_I  :std_logic;
  signal DAT_I  :std_logic_vector(31 downto 0);
  signal DAT_O  :std_logic_vector(31 downto 0);
  signal STB_I  :std_logic;
  signal WE_I   :std_logic;
  
  begin
    dut : mipsmc port map(clk => clk, reset_l => reset_l, ack_o => ack_o, adr_i => adr_i, clk_i => clk_i,
                          dat_i => dat_i, dat_o => dat_o, stb_i => stb_i , we_i => we_i );

    main_mem : memwb port map(ack_o => ack_o, adr_i => adr_i, clk_i => clk_i, dat_i => dat_i,
                              dat_o => dat_o, stb_i => stb_i , we_i => we_i);

    process begin
              clk<='0';
              wait for 5 ns;
              clk<='1';
              wait for 5 ns;
    end process;

    process begin
              reset_l <='0';
              wait for 20 ns;
              reset_l <='1';
              wait for 2000 ns;
    end process;
    
end struct;

